/*
 * pIMONC - IMON-Client for PalmOS, see http://www.fli4l.de/ for details
 *
 * Copyright  2003, Tobias Gruetzmacher
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * See the file COPYING for details.
 *
 */
/**
 * \file
 * \brief Callback-Bugfix, shameless rip from pilot-template ;)
 * \version $Revision$
 * \date $Date$
 * \author Tobias Gruetzmacher
 */

#ifndef __CALLBACK_H__
#define __CALLBACK_H__

/**
 * This is a workaround for a bug in the current version of gcc:
 *
 * gcc assumes that no one will touch %a4 after it is set up in crt0.o.
 * This isn't true if a function is called as a callback by something
 * that wasn't compiled by gcc (like FrmCloseAllForms()).  It may also
 * not be true if it is used as a callback by something in a different
 * shared library.
 *
 * We really want a function attribute "callback" which will insert this
 * progloue and epilogoue automatically.
 *
 *    - Ian
 */

register void *reg_a4 asm("%a4");

#define CALLBACK_PROLOGUE \
	void *save_a4 = reg_a4; asm("move.l %%a5,%%a4; sub.l #edata,%%a4" : :);

#define CALLBACK_EPILOGUE reg_a4 = save_a4;

#endif
/* vi: set tabstop=4 shiftwidth=4: */
